#!/bin/false
# -*- coding: utf-8 -*-
"""
    Bash.org.ru Plugin for svembot (с) 2008 Peter Romov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html>.
"""

import ConfigManager
import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers,MySQLdb,threading

from ConfigManager import *
from PermitionManager import *

log = logging.getLogger("")

class BorLoader:
    def help(self):
        return ""
    conf = None
    permitions = None
    
    mysql_host = None 
    mysql_db = None
    mysql_user = None
    mysql_passwd = None

    update_quotes_url = None
    update_quotes_period = None
    update_abyss_url = None
    update_abyss_period = None

    
    def __init__(self,conf,permitions):
        self.conf = conf
        self.permitions = permitions   
        
        self.mysql_host = self.conf.get("BorPlugin","host")
        self.mysql_db = self.conf.get("BorPlugin","db")
        self.mysql_prefix = self.conf.get("BorPlugin","prefix")
        self.mysql_user = self.conf.get("BorPlugin","user")
        self.mysql_passwd = self.conf.get("BorPlugin","passwd")
        
        self.update_quotes_url = self.conf.get("BorPlugin", "quotes_url")
        self.update_quotes_period = self.conf.get("BorPlugin", "quotes_period")
        self.update_abyss_url = self.conf.get("BorPlugin", "abyss_url")
        self.update_abyss_period = self.conf.get("BorPlugin", "abyss_period")
        
        
    changes = {
        "&quot;":u"\"",
        "&amp;":u"&",
        "&lt;":u"<",
        "&gt;":u">",
        "&nbsp;":u" ",
        "&brvbar;":u"|",
        "&copy;":u"(с)",
        "&laquo;":u"<<",
        "&shy;":u"-",
        "&reg;":u"(r)",
        "&deg;":u"*",
        "&plusmn;":u"+/-",
        "&sup2;":u"^2",
        "&sup3;":u"^3",
        "&acute;":u"\'",
        "&sup1;":u"^1",
        "&raquo;":u">>",
        "&times;":u"x",
        "&divide;":u"/",
        "<br>":u"\n",
        "<br />":u"\n",
        "<br/>":u"\n"
    }

    def decode(self,s):
        for i in self.changes.keys():
            s = string.replace(s,i,self.changes[i])
        return s

    def parse_quotes_bor(self,address):
        try:
            f=urllib.urlopen(address)
            decoder = codecs.lookup("cp1251")[1]
            msg = f.read()
            f.close()
            sps = re.findall("<div class=\"q\">([\x00-\xFF]*?)((<hr class=\"iq\">)|(<div class=\"menu\">)|(<div class=\"aby\">)|(<div class=\"pager\">))",msg)
            quotes = []
            for ii in sps:
                i = ii[0]
                #print ii
                if (i=="" or i.find("text/javascript")!=-1):
                    continue
                j = re.findall("<div[\x00-\xFF]*?</div>",i)
                #print j[0]
                number = re.findall("[0-9]+",j[0])[0]
                prop = re.findall("</a>\]([\x00-\xFF]*?)</div>",j[0])[0].strip()
                try:
                    moder = re.findall("approved by ([\x00-\xFF]*?),",prop)[0]
                except:
                    moder = "none"
                try:
                    date = re.findall(", ([\x00-\xFF]*?)$",prop)[0]
                except:
                    date = re.findall(" ([\- :0-9]*?)$",prop)[0]
                #print moder,date
                quote = self.decode(decoder(j[1][5:-6])[0])
                quotes += [(number,moder,date,quote)]
            return quotes
        except:
            print sys.exc_info()[0],sys.exc_info()[1],"on line:",sys.exc_info()[2].tb_lineno
    
    def parse_quotes_words(self,address):
        try:
            f=urllib.urlopen(address)
            decoder = codecs.lookup("cp1251")[1]
            msg = f.read()
            f.close()
            sps = re.findall("<div class=\"thread\">([\x00-\xFF]*?)((<script language)|(Rating@Mail))",msg)
            quotes = []
            for ii in sps:
                i = ii[0]
                #print ii
                if (i=="" or i.find("text/javascript")!=-1):
                    continue
                j = re.findall("<div class=\"body\">([\x00-\xFF]*?)</div>",i)
                #print j[0]
                number = re.findall("#[0-9]+",i)[0][1:]
                #print i
                #print re.findall("\\(inf\\): ([\x00-\xFF]*?)</small>",i)
                date = re.findall("\\(inf\\): ([\x00-\xFF]*?)</small>",i)[0].strip()
                #print number,date
                quote = self.decode(decoder(j[0])[0].strip())
                quotes += [(number,date,quote)]
            return quotes
        except:
            print sys.exc_info()[0],sys.exc_info()[1],"on line:",sys.exc_info()[2].tb_lineno
            
    def updateQuotes(self):                 
        log.info("Updating quotes...")
        db = MySQLdb.connect(host=self.mysql_host,
                             user=self.mysql_user,
                             passwd=self.mysql_passwd,
                             db=self.mysql_db)
        cursor = db.cursor()
        log.info("Connected to MySQL")
        quotes = self.parse_quotes_bor(self.update_quotes_url)
        log.info("Quotes parsed")
        cnt = 0        
        for q in quotes:      
            try:   
                cursor.execute("""
                        INSERT INTO `"""+self.mysql_prefix+"""quotes` (
                            `NUMBER`,
                            `DATE` ,
                            `MODER`,
                            `TEXT` 
                        )
                        VALUES (
                            '"""+str(q[0])+"""', 
                            '"""+str(q[2])+"""', 
                            '"""+str(q[1])+"""', 
                            '"""+q[3].replace("\\", "\\\\").replace("\'", "\\\'")+"""'
                        )
                    """)
                cnt = cnt + 1
            except: pass
        db.commit()
        log.info("Added quotes: "+str(cnt))
        return cnt
    
    def updateAbyss(self):                 
        log.info("Updating quotes...")
        db = MySQLdb.connect(host=self.mysql_host,
                             user=self.mysql_user,
                             passwd=self.mysql_passwd,
                             db=self.mysql_db)
        cursor = db.cursor()
        log.info("Connected to MySQL")
        quotes = self.parse_quotes_words(self.update_abyss_url)
        log.info("Abyss parsed")
        cnt = 0        
        for q in quotes:  
            try:   
                cursor.execute("""
                        INSERT INTO `"""+self.mysql_prefix+"""abyss` (
                            `NUMBER`,
                            `DATE` ,
                            `TEXT` 
                        )
                        VALUES (
                            '"""+str(q[0])+"""', 
                            '"""+str(q[1])+"""', 
                            '"""+q[2].replace("\\", "\\\\").replace("\'", "\\\'")+"""'
                        )
                    """)
                cnt = cnt + 1
            except: pass
        db.commit()
        log.info("Added quotes: "+str(cnt))
        return cnt

    def processMessage(self,conn,text,who):
        text = text.lower()
        if (text.find("update") == 0):            
            if (not self.permitions.isAdmin(who)):
                return False      
            text = text[len("update"):]
            if (len(text)==0 or (text[0] in ["q", " "])):
                cnt = -1
                cnt = self.updateQuotes()            
                if (cnt != -1):
                    conn.send(xmpp.protocol.Message(who,"Quotes updated: "+str(cnt),"chat"))
            if (len(text)==0 or (text[0] in ["a", " "])):
                cnt = -1      
                cnt = self.updateAbyss()
                if (cnt != -1):
                    conn.send(xmpp.protocol.Message(who,"Abyss updated: "+str(cnt),"chat"))
            return True
        return False
                        
