#!/bin/false
# -*- coding: utf-8 -*-
"""
    Bash.org.ru Plugin for svembot (с) 2008 Peter Romov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html>.
"""

import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers
import MySQLdb

log = logging.getLogger("")

from ConfigManager import *
from PermitionManager import *

class BorPlugin:
    conf = None
    permitions = None
    db = None
    max_quotes = 20
    mysql_host = None 
    mysql_db = None
    mysql_user = None
    mysql_passwd = None
    
    def __init__(self,conf, permitions):
        self.conf = conf
        
        self.mysql_host = self.conf.get("BorPlugin","host")
        self.mysql_db = self.conf.get("BorPlugin","db")
        self.mysql_prefix = self.conf.get("BorPlugin","prefix")
        self.mysql_user = self.conf.get("BorPlugin","user")
        self.mysql_passwd = self.conf.get("BorPlugin","passwd")
        
        self.permitions = permitions
        self.db = MySQLdb.connect(host=self.mysql_host, 
                             db=self.mysql_db, 
                             user=self.mysql_user, 
                             passwd=self.mysql_passwd)
        
   
    def help(self):
        return """
Цитаты:
    .[N] - N(или одна) цитата
    ,[N] - N(или одна) цитат из бездны    
    <N>  - цитата с номером N
    <N> <M> - цитаты в диапазоне N..M (первые 10)
    d - все сегодняшние    
  
Личный профиль:
    q[N] - N(или одна) непрочитанных цитат
    me - состояние вашего профиля
    reset - сбросить счетчик цитат    
  
Специальные команды:
    $ - состояние базы данных цитат
"""
    
    def runSql(self, querry):
        cur = self.db.cursor()
        cur.execute(querry);
        return cur.fetchall()
    
    def table2quotes(self, querry):
        text = ""
        table = self.runSql(querry) 
        for q in table:
            text += "\n--- Цитата #"+str(q[0])+" ---\n"
            text += q[1]
            text += "\n"
        if (text == ""):
            return "По вашему запросу цитат нет"
        else:
            return text    
    
    def getStatus(self):
        quotes_count = self.runSql("""
                SELECT COUNT(NUMBER)
                    FROM """+self.mysql_prefix+"""quotes                
            """)[0][0]
        abyss_count = self.runSql("""
                SELECT COUNT(NUMBER)
                    FROM """+self.mysql_prefix+"""abyss
            """)[0][0]
        return "Кол-во цитат: "+str(quotes_count)+"\n"+\
               "Кол-во цитат бездны: "+str(abyss_count)            
               
    def getRndQuotes(self, n):
        if (n in xrange(0, self.max_quotes+1)):
            return self.table2quotes("""
                    SELECT NUMBER,TEXT
                        FROM """+self.mysql_prefix+"""quotes
                        ORDER BY RAND()
                        LIMIT """+str(n)+"""
                """)
        else:
            return "Ты же лопнешь, деточка"
            
    def getRndAbyss(self, n):
        if (n in xrange(0, self.max_quotes+1)):
            return self.table2quotes("""
                    SELECT NUMBER,TEXT
                        FROM """+self.mysql_prefix+"""abyss
                        ORDER BY RAND()
                        LIMIT """+str(n)+"""
                """)
        else:
            return "Ты же лопнешь, деточка"
        
    def getQuotesRange(self, n, m):
        return self.table2quotes("""
                SELECT NUMBER,TEXT
                    FROM """+self.mysql_prefix+"""quotes
                    WHERE NUMBER BETWEEN '"""+str(n)+"""' AND '"""+str(m)+"""'
                    ORDER BY NUMBER
                    LIMIT """+str(self.max_quotes)+"""
            """)    
        
    def getTodayQuotes(self):
        return self.table2quotes("""
                SELECT NUMBER,TEXT
                    FROM """+self.mysql_prefix+"""quotes
                    WHERE DATE(DATE) = CURRENT_DATE
                    ORDER BY DATE
                    LIMIT """+str(self.max_quotes)+"""
            """)            
        
    def getAbyss(self, n):
        return self.table2quotes("""
                SELECT NUMBER,TEXT
                    FROM """+self.mysql_prefix+"""abyss
                    WHERE NUMBER='"""+str(n)+"""'
            """)     
        
    def createUser(self, jid): 
            self.runSql("""
                    INSERT INTO """+self.mysql_prefix+"""users
                    (
                        JID,
                        REG_DATE,
                        LAST_QUOTE 
                    )
                    VALUES (
                        '"""+jid+"""', 
                        NOW(),
                        (
                            SELECT MIN(NUMBER)
                                FROM quotes
                                WHERE DATE(DATE) >= CURRENT_DATE
                        )
                    )
                """)    
    
    def checkUserExist(self, jid):
        cnt = self.runSql("""
                SELECT COUNT(JID)
                    FROM """+self.mysql_prefix+"""users
                    WHERE JID = '"""+jid+"""'
            """)[0][0]
        if (cnt == 0):
            self.createUser(jid)
    
    def getUserStat(self, jid):
        self.checkUserExist(jid)
        table = self.runSql("""
                SELECT JID, REG_DATE, LAST_QUOTE
                    FROM """+self.mysql_prefix+"""users
                    WHERE JID = '"""+jid+"""'
            """)
        notread_quotes = self.runSql("""
                SELECT COUNT(NUMBER)
                    FROM """+self.mysql_prefix+"""quotes
                    WHERE NUMBER > (
                        SELECT LAST_QUOTE
                            FROM """+self.mysql_prefix+"""users
                            WHERE JID = '"""+jid+"""'
                    )
            """)[0][0]
        return """User """+str(table[0][0])+"""
У вас """+str(notread_quotes)+""" непрочитанных цитат
Дата регистрации: """+str(table[0][1])

    def resetUser(self, jid):
        self.checkUserExist(jid)
        self.runSql("""
                UPDATE """+self.mysql_prefix+"""users
                    SET LAST_QUOTE = 
                        (
                            SELECT MAX(NUMBER)
                                FROM """+self.mysql_prefix+"""quotes
                        )
                    WHERE JID = '"""+jid+"""'
            """)   
        
    def getUserQuotes(self, jid, n):             
        self.checkUserExist(jid)
        if (n in xrange(0, self.max_quotes+1)):
            res = self.table2quotes("""
                    SELECT NUMBER,TEXT
                        FROM """+self.mysql_prefix+"""quotes
                        WHERE NUMBER > (
                                SELECT LAST_QUOTE
                                    FROM """+self.mysql_prefix+"""users
                                    WHERE JID = '"""+jid+"""'
                            )
                        ORDER BY NUMBER
                        LIMIT """+str(n)+"""                        
                """)
            if (res == ""):
                return "У вас нет непрочитаных цитат"
            else:
                if (n != 0):
                    try:
                        max_date = self.runSql("""
                            SELECT NUMBER
                                FROM """+self.mysql_prefix+"""quotes
                                WHERE NUMBER > (
                                    SELECT LAST_QUOTE
                                        FROM """+self.mysql_prefix+"""users
                                        WHERE JID = '"""+jid+"""'
                                )
                                ORDER BY DATE
                                LIMIT """+str(n-1)+""", 1
                            """)[0][0]
                        self.runSql("""
                            UPDATE """+self.mysql_prefix+"""users
                                SET LAST_QUOTE = '"""+str(max_date)+"""'
                                WHERE JID = '"""+jid+"""'
                            """)
                    except: pass
            return res
        else:
            return "Ты же лопнешь, деточка"       
                   
    def processMessage(self,conn,text,who):
        text = text.lower().strip()
        jid = who.getNode()+"@"+who.getDomain()
        # Command $
        if (text.find("$")==0):
            conn.send(xmpp.protocol.Message(who,self.getStatus(),"chat"))
            return True
        # Command .<N>
        if ((text.find(".")==0) or (u"жЖэЭбюх".find(text)>=0)):
            cnt = 1
            try: cnt = int(text[1:].strip())
            except: pass
            conn.send(xmpp.protocol.Message(who,self.getRndQuotes(cnt),"chat"))
            return True        
        # Command ,<N>
        if (text.find(",")==0):
            cnt = 1
            try: cnt = int(text[1:].strip())
            except: pass
            conn.send(xmpp.protocol.Message(who,self.getRndAbyss(cnt),"chat"))
            return True
        # Command d
        if (text.find("d")==0):
            conn.send(xmpp.protocol.Message(who,self.getTodayQuotes(),"chat"))
            return True
        # Command me
        if (text.find("me")==0):
            conn.send(xmpp.protocol.Message(who,self.getUserStat(jid),"chat"))
            return True
        # Command reset
        if (text.find("reset")==0):
            self.resetUser(jid)
            conn.send(xmpp.protocol.Message(who,"Состояние вашей учетной записи изменено. Введите me для просмотра.","chat"))
            return True
        # Command q[N]
        if (text.find("q")==0):
            cnt = 1
            try: cnt = int(text[1:].strip())
            except: pass
            conn.send(xmpp.protocol.Message(who,self.getUserQuotes(jid, cnt),"chat"))
            return True         
        # Command <N> <M>
        n = -1
        m = -1
        try: 
            params = text.strip().split(" ")
            n = int(params[0])
            m = n
            m = int(params[1])
        except: pass
        if (n >= 0):
            conn.send(xmpp.protocol.Message(who,self.getQuotesRange(n,m),"chat"))
            return True
        return False
           
