#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
    Svem jabber bot
    Copyright (C) 2007-2008 Sergey Melnikov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html>.
"""
from BotVersion import VERSION 

import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers

log = logging.getLogger("")
#log.setLevel(logging.DEBUG)
log.setLevel(logging.INFO)
logname = "bot.log"
hdlr = logging.handlers.RotatingFileHandler(logname, "a", 5*1024*1024, 1)
fmt = logging.Formatter("%(asctime)s %(levelname)-5s %(message)s", "%x %X")
hdlr.setFormatter(fmt)
log.addHandler(hdlr)


from ConfigManager import *
conf = ConfigManager()
from PermitionManager import *
permitions = PermitionManager(conf)


conf.readConfig()

from PluginsList import *

pl = PluginsList(conf,permitions)
plugins = pl.getPlugins() 
needtimer = pl.getNeedTimer()

def subscriber(conn,msg):
    try:
        type=msg.getType()
        who=msg.getFrom()
        if type == "subscribe":
            conn.send(xmpp.Presence(to=who, typ = 'subscribed'))
            conn.send(xmpp.Presence(to=who, typ = 'subscribe'))
    except:
        pass

def messageCB(conn,msg):
    try:
        type=msg.getType()
        who=msg.getFrom()
        text=unicode(msg.getBody())
        log.info(u"Sender: " + unicode(who))
        log.info(u"Content: " + unicode(text))
        log.info(u"Type: "+ unicode(type))
        log.debug(unicode(who).find("@"))
        if type == "subscribe":
            conn.send(xmpp.Presence(to=who, type = 'subscribed'))
            conn.send(xmpp.Presence(to=who, type = 'subscribe'))
        if (unicode(who).find("@")==-1):
            return
        if (unicode(type)!="chat"):
            return
        if (len(text)==0):
            return
        if (permitions.isBanned(who)):
            conn.send(xmpp.protocol.Message(who,"Вы забанены!\nнаверно на то была причина...","chat"))
            return
        if (text.find("!")==0):
            text = text[1:]
        if (text.lower().find("help")==0 or text.lower().find(u"помощь")==0 or text.lower().find(u"?")==0):
            msg = """
Я Svem's Jabber Bot, версия """+VERSION+""" на """+conf.jid_str+""" © 2007-2008 Сергей Мельников

Функции:
    help,помощь,? - эта помощь.        
"""
            for p in plugins:
                msg += p.help()
            msg += """
"""
            log.debug("help send")
            conn.send(xmpp.protocol.Message(who,msg,"chat"))
        else:
            for p in plugins:
                try:
                #if (True):
                    if (p.processMessage(conn,text,who)):
                        log.info("send by"+str(p)+"\n")
                        break
                except Exception, e:
                #if (False):
                    print sys.exc_info()[0],sys.exc_info()[1],"on line:",sys.exc_info()[2].tb_lineno
                    log.warn("Внимание исключение из плагина:"+str(p)+"\n\n"+str(e))
                    conn.send(xmpp.protocol.Message(who,"Внимание исключение из плагина:"+str(p)+" (это или баг бота или документированый недостаток его)","chat"))
                    break
            else:
                conn.send(xmpp.protocol.Message(who,"неизвестная команда\nдля справки отправьте help\nВНИМАНИЕ! это сообщение скорее всего никто никогда не прочитает,отправьте msg admin <сообщение> , если хотите отправить сообщение админу","chat"))
    except Exception, e:
        print sys.exc_info()[0],sys.exc_info()[1],"on line:",sys.exc_info()[2].tb_lineno
        log.error("Глобальное исключение!")

def StepOn(conn):
    try:
        conn.Process(1)
    except KeyboardInterrupt:
        return False
    return True


def GoOn(conn):
    #keepalive = int(time.time())
    keepalive = 0
    lasttimer = 0
    while StepOn(conn):
        if (int(time.time())-keepalive>conf.keepalive_delay):
            conn.send(xmpp.protocol.Presence())
            log.debug("keepalive "+str(int(time.time())))
            keepalive = int(time.time())
        if (int(time.time())-lasttimer>conf.timer):
            for p in needtimer:
                try:
                    p.update()
                except:
                    log.warn("except in update in"+str(p))
            lasttimer = int(time.time())
def main():
    jid=xmpp.protocol.JID(conf.jid_str)
    cl = xmpp.Client(jid.getDomain(), debug=[])
    cl.connect(secure=0)
    cl.auth(jid.getNode(),conf.password,conf.resource)
    cl.RegisterHandler('message', messageCB)
    cl.RegisterHandler('presence', subscriber)
    cl.sendInitPresence()
    GoOn(cl)

main()

log.removeHandler(hdlr)