#!/bin/false
# -*- coding: utf-8 -*-
"""
    Svem jabber bot
    Copyright (C) 2008 Sergey Melnikov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html>.
"""

import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers

log = logging.getLogger("")

from ConfigManager import *
from PermitionManager import *

class FortunePlugin:
    conf = None
    permitions = None
    chapters = None
    
    quotes = {}
    allquotes = []
    
    def __init__(self,conf, permitions):
        self.conf = conf
        self.chapters = self.conf.get("Fortune","chapters").split(",")
        self.directory = self.conf.get("Fortune","directory")
        self.permitions = permitions
        self.load()
    
    
    def load(self):
        for chap in self.chapters:
            if chap=="":
                continue
            f=codecs.open(self.directory+chap, "rb","utf-8")
            msg = f.read()
            f.close()
            self.quotes[chap] = msg.split("%\n")
            self.allquotes += self.quotes[chap]
        
    def help(self):
        return "Fortune:\n flist - перечислить разделы\n f[ <раздел>|<номер раздела>] - получить высказывание[ из раздела]\n"
    
    def processMessage(self,conn,text,who):
        if (text.lower().find("flist")==0):
            conn.send(xmpp.protocol.Message(who,str(self.chapters),"chat"))
            return True
        if (text.lower().find("f")==0 or text.lower().find(u"ф")==0):
            chapter = text.lower()[1:].strip()
            if (len(chapter)>0):
                if (self.quotes.has_key(chapter)):
                    d = self.quotes[chapter]
                    conn.send(xmpp.protocol.Message(who,d[random.randrange(0,len(d))],"chat"))
                else:
                    ch = -1
                    try:
                        ch = int(chapter)
                    except:
                        pass
                    if (0<=ch<len(self.quotes.keys())):
                        d = self.quotes[self.quotes.keys()[ch]]
                        conn.send(xmpp.protocol.Message(who,d[random.randrange(0,len(d))],"chat"))
                    else:
                        conn.send(xmpp.protocol.Message(who,u"такого раздела нет","chat"))
            else:
                d = self.allquotes
                conn.send(xmpp.protocol.Message(who,d[random.randrange(0,len(d))],"chat"))
            
            return True
        return False
