#!/bin/false
# -*- coding: utf-8 -*-
"""
    Svem jabber bot
    Copyright (C) 2007 Sergey Melnikov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html>.
"""

import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers

log = logging.getLogger("")

from ConfigManager import *
from PermitionManager import *

class MaximaPlugin:
    conf = None
    permitions = None
    
    allow_commands = ['solve', 'integrate', 'diff', 'dsolve', 'ode2', 'factor', 'ratsimp', 'trigreduce', 'expand', 'rectform', 'trigsimp', 'trigexpand', 'solveradcan']
    
    def __init__(self,conf, permitions):
        self.conf = conf
        self.permitions = permitions

    def help(self):
        self.allow_commands.sort()
        text = "    maxima - выполнить команду в Maxima (выполняется только с advanced jid'ов) доки можно почитать тут http://maxima.sourceforge.net/ru/maxima-tarnavsky-4.html\n\
            calc - посчитать выражение\n\
            Также разрешены команды:\n"
        for i in self.allow_commands:
            text += "                "+i+"\n";
        return text
        
    
    def run(self,text):
        """
        Этот участок крайне нестабилен, и вообще-то его не следует его исполнять никому кроме админов!
        """
        log.info("try run maxima with "+text)
        f=codecs.open("./svembot_maxima_task", "wb","utf-8")
        f.write("display2d:false;\n"+str(text)+"\n")
        f.close()
        os.system("echo none > ./svembot_maxima_output");
        os.system("echo none > ./svembot_maxima_error");
        pr = "/usr/bin/execute --input=/dev/null --output=./svembot_maxima_output --error=./svembot_maxima_error --time-limit-millis=500 --real-time-limit=10 /usr/bin/maxima -b ./svembot_maxima_task  2>./svembot_maxima_error >./svembot_maxima_output"
        #pr= "/usr/bin/maxima -b svembot_maxima_task >svembot_maxima_output"
        os.system(pr)
        f=codecs.open("./svembot_maxima_output", "rb","utf-8")
        msg = f.read()
        f.close()
        f=codecs.open("./svembot_maxima_error", "rb","utf-8")
        err = f.read()
        f.close()
        if (err.find("TL")>=0):
            return "Maxima error: Time Limit Exceeded"
        if (err.find("RE")>=0):
            return "Maxima error: Runtime Error"
        log.info("run maxima ok")
        if (msg.find("Incorrect syntax") != -1):
            return "Maxima: Incorrect syntax"
        p = msg.find("(%o3)")
        if (p != -1):
            msg = msg[p+5:]
            newln = msg.find("\n")
            if (newln != -1):
                msg = msg[:newln]
            return "Result: "+msg
        return "Maxima: Error"

    def processMessage(self,conn,text,who):
        if (text.lower().find("maxima")==0):
            if (not self.permitions.isAdvanced(who)):
                conn.send(xmpp.protocol.Message(who,"Ваш jid не включен в список advanced, отправьте сообщение админу, если думаете, что он может вас туда добавить...","chat"))
                return True
            text = text[7:]
            conn.send(xmpp.protocol.Message(who,self.run(text),"chat"))
            return True
        if (text.lower().find("calc") == 0):
            text = text[len("calc"):]
            if (text.find(";") != -1):
                    conn.send(xmpp.protocol.Message(who,"Брось каку! Низя так делать!","chat"))
                    return True
            conn.send(xmpp.protocol.Message(who,self.run("solve(res="+text+");"),"chat"))
            return True        
        p = text.find(" ")
        if (p != -1):        
            cmd = text[:text.find(" ")].lower()
            if (cmd in self.allow_commands):
                text = text[len(cmd):]
                if (text.find(";") != -1):
                    conn.send(xmpp.protocol.Message(who,"Брось каку! Низя так делать!","chat"))
                    return True
                conn.send(xmpp.protocol.Message(who,self.run(cmd+"("+text+");"),"chat"))
                return True            